
package controls;

import java.beans.*;

import java.lang.reflect.Method;
import java.lang.reflect.UndeclaredThrowableException;
import java.util.HashMap;
import java.util.Map;

import org.apache.beehive.controls.api.bean.*;
import org.apache.beehive.controls.api.context.ControlBeanContext;
import org.apache.beehive.controls.api.properties.PropertyKey;
import org.apache.beehive.controls.api.properties.PropertyMap;
import org.apache.beehive.controls.api.versioning.*;

@SuppressWarnings("all")
public class DSPControlFileBean
extends com.bea.dsp.control.core.DSPControlBean
implements controls.DSPControlFile
{
    static final Method _getServiceCasesMethod;
    static final Method _createPROFILEMethod;
    static final Method _getCustomerByCustIDMethod;
    static final Method _getOrderCountsMethod;
    static final Method _getCustomerByLoginID0Method;
    static final Method _updatePROFILEMethod;
    static final Method _getCustomerServiceMethod;
    static final Method _invokeMethod;
    static final Method _executeProcedureMethod;
    static final Method _deletePROFILEMethod;
    static final Method _getCustomerByLoginID1Method;
    static final Method _getCustomerByZipIDMethod;
    static final Method _executeQuery2Method;
    static final Method _getOrderCountMethod;
    static final Method _executeQuery1Method;
    static final Method _getProfileMethod;
    static final Method _executeQuery0Method;
    static final Method _getServiceCaseMethod;
    
    //
    // This HashMap will map from a Method to the array of names for parameters of the
    // method.  This is necessary because parameter name data isn't carried along in the
    // class file, but if available can enable ease of use by referencing parameters by
    // the declared name (vs. by index).
    //
    // This map should be read-only after its initialization in the static block, hence
    // using a plain HashMap is thread-safe.
    //
    static HashMap<Method, String []> _methodParamMap = new HashMap<Method, String []>();
    
    static
    {
        
        
        try
        {
            _getServiceCasesMethod = controls.DSPControlFile.class.getMethod("getServiceCases", new Class [] {retailer.PROFILE_SERVICES.class});
            _methodParamMap.put(_getServiceCasesMethod, new String [] { "profiles" });
            _createPROFILEMethod = controls.DSPControlFile.class.getMethod("createPROFILE", new Class [] {retailer.PROFILE_SERVICE[].class});
            _methodParamMap.put(_createPROFILEMethod, new String [] { "profile" });
            _getCustomerByCustIDMethod = controls.DSPControlFile.class.getMethod("getCustomerByCustID", new Class [] {java.lang.String.class});
            _methodParamMap.put(_getCustomerByCustIDMethod, new String [] { "custID" });
            _getOrderCountsMethod = controls.DSPControlFile.class.getMethod("getOrderCounts", new Class [] {java.lang.String.class});
            _methodParamMap.put(_getOrderCountsMethod, new String [] { "arg" });
            _getCustomerByLoginID0Method = controls.DSPControlFile.class.getMethod("getCustomerByLoginID", new Class [] {java.lang.String.class});
            _methodParamMap.put(_getCustomerByLoginID0Method, new String [] { "loginID" });
            _updatePROFILEMethod = controls.DSPControlFile.class.getMethod("updatePROFILE", new Class [] {retailer.PROFILE_SERVICE[].class});
            _methodParamMap.put(_updatePROFILEMethod, new String [] { "profile" });
            _getCustomerServiceMethod = controls.DSPControlFile.class.getMethod("getCustomerService", new Class [] {retailer.PROFILE_SERVICE.class});
            _methodParamMap.put(_getCustomerServiceMethod, new String [] { "profile" });
            _invokeMethod = controls.DSPControlFile.class.getMethod("invoke", new Class [] {java.lang.String.class, java.lang.Object[].class});
            _methodParamMap.put(_invokeMethod, new String [] { "functionName", "params" });
            _executeProcedureMethod = controls.DSPControlFile.class.getMethod("executeProcedure", new Class [] {java.lang.String.class, com.bea.ld.ExternalVariables.class});
            _methodParamMap.put(_executeProcedureMethod, new String [] { "xquery", "params" });
            _deletePROFILEMethod = controls.DSPControlFile.class.getMethod("deletePROFILE", new Class [] {retailer.PROFILE_SERVICE[].class});
            _methodParamMap.put(_deletePROFILEMethod, new String [] { "profile" });
            _getCustomerByLoginID1Method = controls.DSPControlFile.class.getMethod("getCustomerByLoginID", new Class [] {java.lang.String.class, com.bea.dsp.RequestConfig.class});
            _methodParamMap.put(_getCustomerByLoginID1Method, new String [] { "loginID", "config" });
            _getCustomerByZipIDMethod = controls.DSPControlFile.class.getMethod("getCustomerByZipID", new Class [] {java.lang.String.class});
            _methodParamMap.put(_getCustomerByZipIDMethod, new String [] { "zipID" });
            _executeQuery2Method = controls.DSPControlFile.class.getMethod("executeQuery", new Class [] {java.lang.String.class, com.bea.ld.ExternalVariables.class, com.bea.dsp.RequestConfig.class});
            _methodParamMap.put(_executeQuery2Method, new String [] { "xquery", "params", "config" });
            _getOrderCountMethod = controls.DSPControlFile.class.getMethod("getOrderCount", new Class [] {java.lang.String.class});
            _methodParamMap.put(_getOrderCountMethod, new String [] { "arg" });
            _executeQuery1Method = controls.DSPControlFile.class.getMethod("executeQuery", new Class [] {java.lang.String.class, com.bea.ld.ExternalVariables.class});
            _methodParamMap.put(_executeQuery1Method, new String [] { "xquery", "params" });
            _getProfileMethod = controls.DSPControlFile.class.getMethod("getProfile", new Class [] {});
            _methodParamMap.put(_getProfileMethod, new String [] {  });
            _executeQuery0Method = controls.DSPControlFile.class.getMethod("executeQuery", new Class [] {java.lang.String.class});
            _methodParamMap.put(_executeQuery0Method, new String [] { "xquery" });
            _getServiceCaseMethod = controls.DSPControlFile.class.getMethod("getServiceCase", new Class [] {retailer.PROFILE_SERVICE.class});
            _methodParamMap.put(_getServiceCaseMethod, new String [] { "profile" });
        }
        catch (NoSuchMethodException __bc_nsme)
        {
            throw new ExceptionInInitializerError(__bc_nsme);
        }
    }
    
    
    
    static
    {
        
    }
    
    
    
    /**
    * This is the public constructor for the class.  A client-defined control ID may
    * be provided.  This ID must be unique within the nesting ControlBeanContext.
    * @param context The containing ControlBeanContext
    * @param id The control identifier (or null to autogenerate a unique value)
    * @param props The initialization Properties for the new instance (or null for defaults)
    */
    public DSPControlFileBean(ControlBeanContext context, String id, PropertyMap props)
    {
        this(context, id, props, controls.DSPControlFile.class);
    }
    
    /**
    * This is the public null-arg constructor for this ControlBean.  If a control id
    * is not provided, a unique value will be auto-generated.
    */
    public DSPControlFileBean()
    {
        this(null, null, null);
    }
    
    /**
    * This is the protected version that is used by any ControlBean subclass
    */
    protected DSPControlFileBean(ControlBeanContext context, String id, PropertyMap props, Class controlClass)
    {
        super(context, id, props, controlClass);
        
    }
    
    
    /**
    * Returns an array of parameter names for the request method, or null if no parameter
    * data is available.
    */
    protected String [] getParameterNames(Method m)
    {
        // Check the local map for operations on this bean type
        if (_methodParamMap.containsKey(m))
        {
            return _methodParamMap.get(m);
        }
        
        // Delegate up if not found locally
        return super.getParameterNames(m);
    }
    
    /**
    * Implements controls.DSPControlFile.getServiceCases
    */
    public  retailer.CASE_SERVICE[] getServiceCases(retailer.PROFILE_SERVICES profiles) 
    {
        Object [] __bc_argArray = new Object[] { profiles };
        Throwable __bc_thrown = null;
        Extensible __bc_target = (Extensible)ensureControl();
        retailer.CASE_SERVICE[] __bc_retval = null;
        
        try
        {
            preInvoke(_getServiceCasesMethod, __bc_argArray);
            
            __bc_retval =
            (retailer.CASE_SERVICE[])
            __bc_target.invoke(_getServiceCasesMethod, __bc_argArray)
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = __bc_retval;
            postInvoke(_getServiceCasesMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
        return __bc_retval;
    }
    
    /**
    * Implements controls.DSPControlFile.createPROFILE
    */
    public  retailer.ProfileService_KEY[] createPROFILE(retailer.PROFILE_SERVICE[] profile) 
    {
        Object [] __bc_argArray = new Object[] { profile };
        Throwable __bc_thrown = null;
        Extensible __bc_target = (Extensible)ensureControl();
        retailer.ProfileService_KEY[] __bc_retval = null;
        
        try
        {
            preInvoke(_createPROFILEMethod, __bc_argArray);
            
            __bc_retval =
            (retailer.ProfileService_KEY[])
            __bc_target.invoke(_createPROFILEMethod, __bc_argArray)
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = __bc_retval;
            postInvoke(_createPROFILEMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
        return __bc_retval;
    }
    
    /**
    * Implements controls.DSPControlFile.getCustomerByCustID
    */
    public  retailer.PROFILE_SERVICE[] getCustomerByCustID(java.lang.String custID) 
    {
        Object [] __bc_argArray = new Object[] { custID };
        Throwable __bc_thrown = null;
        Extensible __bc_target = (Extensible)ensureControl();
        retailer.PROFILE_SERVICE[] __bc_retval = null;
        
        try
        {
            preInvoke(_getCustomerByCustIDMethod, __bc_argArray);
            
            __bc_retval =
            (retailer.PROFILE_SERVICE[])
            __bc_target.invoke(_getCustomerByCustIDMethod, __bc_argArray)
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = __bc_retval;
            postInvoke(_getCustomerByCustIDMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
        return __bc_retval;
    }
    
    /**
    * Implements controls.DSPControlFile.getOrderCounts
    */
    public  java.math.BigInteger[] getOrderCounts(java.lang.String arg) 
    {
        Object [] __bc_argArray = new Object[] { arg };
        Throwable __bc_thrown = null;
        Extensible __bc_target = (Extensible)ensureControl();
        java.math.BigInteger[] __bc_retval = null;
        
        try
        {
            preInvoke(_getOrderCountsMethod, __bc_argArray);
            
            __bc_retval =
            (java.math.BigInteger[])
            __bc_target.invoke(_getOrderCountsMethod, __bc_argArray)
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = __bc_retval;
            postInvoke(_getOrderCountsMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
        return __bc_retval;
    }
    
    /**
    * Implements controls.DSPControlFile.getCustomerByLoginID
    */
    public  retailer.PROFILE_SERVICE[] getCustomerByLoginID(java.lang.String loginID) 
    {
        Object [] __bc_argArray = new Object[] { loginID };
        Throwable __bc_thrown = null;
        Extensible __bc_target = (Extensible)ensureControl();
        retailer.PROFILE_SERVICE[] __bc_retval = null;
        
        try
        {
            preInvoke(_getCustomerByLoginID0Method, __bc_argArray);
            
            __bc_retval =
            (retailer.PROFILE_SERVICE[])
            __bc_target.invoke(_getCustomerByLoginID0Method, __bc_argArray)
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = __bc_retval;
            postInvoke(_getCustomerByLoginID0Method, __bc_argArray, __bc_rv, __bc_thrown);
        }
        return __bc_retval;
    }
    
    /**
    * Implements controls.DSPControlFile.updatePROFILE
    */
    public  void updatePROFILE(retailer.PROFILE_SERVICE[] profile) 
    {
        Object [] __bc_argArray = new Object[] { profile };
        Throwable __bc_thrown = null;
        Extensible __bc_target = (Extensible)ensureControl();
        
        try
        {
            preInvoke(_updatePROFILEMethod, __bc_argArray);
            
            __bc_target.invoke(_updatePROFILEMethod, __bc_argArray)
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = null;
            postInvoke(_updatePROFILEMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
    }
    
    /**
    * Implements controls.DSPControlFile.getCustomerService
    */
    public  retailer.CUSTOMER_SERVICE getCustomerService(retailer.PROFILE_SERVICE profile) 
    {
        Object [] __bc_argArray = new Object[] { profile };
        Throwable __bc_thrown = null;
        Extensible __bc_target = (Extensible)ensureControl();
        retailer.CUSTOMER_SERVICE __bc_retval = null;
        
        try
        {
            preInvoke(_getCustomerServiceMethod, __bc_argArray);
            
            __bc_retval =
            (retailer.CUSTOMER_SERVICE)
            __bc_target.invoke(_getCustomerServiceMethod, __bc_argArray)
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = __bc_retval;
            postInvoke(_getCustomerServiceMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
        return __bc_retval;
    }
    
    /**
    * Implements controls.DSPControlFile.invoke
    */
    public  commonj.sdo.DataObject[] invoke(java.lang.String functionName, java.lang.Object[] params) 
    {
        Object [] __bc_argArray = new Object[] { functionName, params };
        Throwable __bc_thrown = null;
        Extensible __bc_target = (Extensible)ensureControl();
        commonj.sdo.DataObject[] __bc_retval = null;
        
        try
        {
            preInvoke(_invokeMethod, __bc_argArray);
            
            __bc_retval =
            (commonj.sdo.DataObject[])
            __bc_target.invoke(_invokeMethod, __bc_argArray)
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = __bc_retval;
            postInvoke(_invokeMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
        return __bc_retval;
    }
    
    /**
    * Implements controls.DSPControlFile.executeProcedure
    */
    public  java.lang.Object[] executeProcedure(java.lang.String xquery, com.bea.ld.ExternalVariables params) 
    {
        Object [] __bc_argArray = new Object[] { xquery, params };
        Throwable __bc_thrown = null;
        Extensible __bc_target = (Extensible)ensureControl();
        java.lang.Object[] __bc_retval = null;
        
        try
        {
            preInvoke(_executeProcedureMethod, __bc_argArray);
            
            __bc_retval =
            (java.lang.Object[])
            __bc_target.invoke(_executeProcedureMethod, __bc_argArray)
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = __bc_retval;
            postInvoke(_executeProcedureMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
        return __bc_retval;
    }
    
    /**
    * Implements controls.DSPControlFile.deletePROFILE
    */
    public  void deletePROFILE(retailer.PROFILE_SERVICE[] profile) 
    {
        Object [] __bc_argArray = new Object[] { profile };
        Throwable __bc_thrown = null;
        Extensible __bc_target = (Extensible)ensureControl();
        
        try
        {
            preInvoke(_deletePROFILEMethod, __bc_argArray);
            
            __bc_target.invoke(_deletePROFILEMethod, __bc_argArray)
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = null;
            postInvoke(_deletePROFILEMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
    }
    
    /**
    * Implements controls.DSPControlFile.getCustomerByLoginID
    */
    public  retailer.PROFILE_SERVICE[] getCustomerByLoginID(java.lang.String loginID, com.bea.dsp.RequestConfig config) 
    {
        Object [] __bc_argArray = new Object[] { loginID, config };
        Throwable __bc_thrown = null;
        Extensible __bc_target = (Extensible)ensureControl();
        retailer.PROFILE_SERVICE[] __bc_retval = null;
        
        try
        {
            preInvoke(_getCustomerByLoginID1Method, __bc_argArray);
            
            __bc_retval =
            (retailer.PROFILE_SERVICE[])
            __bc_target.invoke(_getCustomerByLoginID1Method, __bc_argArray)
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = __bc_retval;
            postInvoke(_getCustomerByLoginID1Method, __bc_argArray, __bc_rv, __bc_thrown);
        }
        return __bc_retval;
    }
    
    /**
    * Implements controls.DSPControlFile.getCustomerByZipID
    */
    public  retailer.PROFILE_SERVICE[] getCustomerByZipID(java.lang.String zipID) 
    {
        Object [] __bc_argArray = new Object[] { zipID };
        Throwable __bc_thrown = null;
        Extensible __bc_target = (Extensible)ensureControl();
        retailer.PROFILE_SERVICE[] __bc_retval = null;
        
        try
        {
            preInvoke(_getCustomerByZipIDMethod, __bc_argArray);
            
            __bc_retval =
            (retailer.PROFILE_SERVICE[])
            __bc_target.invoke(_getCustomerByZipIDMethod, __bc_argArray)
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = __bc_retval;
            postInvoke(_getCustomerByZipIDMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
        return __bc_retval;
    }
    
    /**
    * Implements controls.DSPControlFile.executeQuery
    */
    public  java.lang.Object[] executeQuery(java.lang.String xquery, com.bea.ld.ExternalVariables params, com.bea.dsp.RequestConfig config) 
    {
        Object [] __bc_argArray = new Object[] { xquery, params, config };
        Throwable __bc_thrown = null;
        Extensible __bc_target = (Extensible)ensureControl();
        java.lang.Object[] __bc_retval = null;
        
        try
        {
            preInvoke(_executeQuery2Method, __bc_argArray);
            
            __bc_retval =
            (java.lang.Object[])
            __bc_target.invoke(_executeQuery2Method, __bc_argArray)
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = __bc_retval;
            postInvoke(_executeQuery2Method, __bc_argArray, __bc_rv, __bc_thrown);
        }
        return __bc_retval;
    }
    
    /**
    * Implements controls.DSPControlFile.getOrderCount
    */
    public  java.math.BigInteger getOrderCount(java.lang.String arg) 
    {
        Object [] __bc_argArray = new Object[] { arg };
        Throwable __bc_thrown = null;
        Extensible __bc_target = (Extensible)ensureControl();
        java.math.BigInteger __bc_retval = null;
        
        try
        {
            preInvoke(_getOrderCountMethod, __bc_argArray);
            
            __bc_retval =
            (java.math.BigInteger)
            __bc_target.invoke(_getOrderCountMethod, __bc_argArray)
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = __bc_retval;
            postInvoke(_getOrderCountMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
        return __bc_retval;
    }
    
    /**
    * Implements controls.DSPControlFile.executeQuery
    */
    public  java.lang.Object[] executeQuery(java.lang.String xquery, com.bea.ld.ExternalVariables params) 
    {
        Object [] __bc_argArray = new Object[] { xquery, params };
        Throwable __bc_thrown = null;
        Extensible __bc_target = (Extensible)ensureControl();
        java.lang.Object[] __bc_retval = null;
        
        try
        {
            preInvoke(_executeQuery1Method, __bc_argArray);
            
            __bc_retval =
            (java.lang.Object[])
            __bc_target.invoke(_executeQuery1Method, __bc_argArray)
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = __bc_retval;
            postInvoke(_executeQuery1Method, __bc_argArray, __bc_rv, __bc_thrown);
        }
        return __bc_retval;
    }
    
    /**
    * Implements controls.DSPControlFile.getProfile
    */
    public  retailer.PROFILE_SERVICE[] getProfile() 
    {
        Object [] __bc_argArray = new Object[] {  };
        Throwable __bc_thrown = null;
        Extensible __bc_target = (Extensible)ensureControl();
        retailer.PROFILE_SERVICE[] __bc_retval = null;
        
        try
        {
            preInvoke(_getProfileMethod, __bc_argArray);
            
            __bc_retval =
            (retailer.PROFILE_SERVICE[])
            __bc_target.invoke(_getProfileMethod, __bc_argArray)
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = __bc_retval;
            postInvoke(_getProfileMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
        return __bc_retval;
    }
    
    /**
    * Implements controls.DSPControlFile.executeQuery
    */
    public  java.lang.Object[] executeQuery(java.lang.String xquery) 
    {
        Object [] __bc_argArray = new Object[] { xquery };
        Throwable __bc_thrown = null;
        Extensible __bc_target = (Extensible)ensureControl();
        java.lang.Object[] __bc_retval = null;
        
        try
        {
            preInvoke(_executeQuery0Method, __bc_argArray);
            
            __bc_retval =
            (java.lang.Object[])
            __bc_target.invoke(_executeQuery0Method, __bc_argArray)
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = __bc_retval;
            postInvoke(_executeQuery0Method, __bc_argArray, __bc_rv, __bc_thrown);
        }
        return __bc_retval;
    }
    
    /**
    * Implements controls.DSPControlFile.getServiceCase
    */
    public  retailer.CASE_SERVICE[] getServiceCase(retailer.PROFILE_SERVICE profile) 
    {
        Object [] __bc_argArray = new Object[] { profile };
        Throwable __bc_thrown = null;
        Extensible __bc_target = (Extensible)ensureControl();
        retailer.CASE_SERVICE[] __bc_retval = null;
        
        try
        {
            preInvoke(_getServiceCaseMethod, __bc_argArray);
            
            __bc_retval =
            (retailer.CASE_SERVICE[])
            __bc_target.invoke(_getServiceCaseMethod, __bc_argArray)
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = __bc_retval;
            postInvoke(_getServiceCaseMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
        return __bc_retval;
    }
    
    
    /**
    * A PropertyKey that can be used to access the controlImplementation property of the
    * BaseProperties PropertySet
    */
    public static final PropertyKey ControlImplementationKey = new PropertyKey(org.apache.beehive.controls.api.properties.BaseProperties.class, "controlImplementation");
    
    public synchronized void setControlImplementation(java.lang.String value)
    {
        
        setControlProperty(ControlImplementationKey, value);
    }
    
    public java.lang.String getControlImplementation()
    {
        return (java.lang.String)getControlProperty(ControlImplementationKey);
    }
    
    
    
    
    
    /**
    * The _annotCache maintains a lookup cache from AnnotatedElements to an associated
    * PropertyMap.  This enables these maps to be shared across multiple beans.
    */
    static private HashMap __bc_annotCache = new HashMap();
    
    protected Map getPropertyMapCache() { return __bc_annotCache; }
    
    private static final long serialVersionUID = 1L;
}
